import * as tslib_1 from "tslib";
import * as React from 'react';
import FaBookmarkO from 'react-icons/lib/fa/bookmark-o';
import styled from 'styled-components';
import Button from '../Button';
import { Box, Flex } from '../Grid';
import Input from '../Input';
import Modal from '../Modal';
import Select from '../Select';
import Txt from '../Txt';
import FilterDescription from './FilterDescription';
var BorderedDiv = styled.div(templateObject_1 || (templateObject_1 = tslib_1.__makeTemplateObject(["\n\tmargin-top: 15px;\n\tpadding: 6px 11px 0;\n\tborder: solid 1px #979797;\n"], ["\n\tmargin-top: 15px;\n\tpadding: 6px 11px 0;\n\tborder: solid 1px #979797;\n"])));
var FilterSummary = (function (_super) {
    tslib_1.__extends(FilterSummary, _super);
    function FilterSummary(props) {
        var _this = _super.call(this, props) || this;
        _this.save = function (event) {
            if (event) {
                event.preventDefault();
            }
            var _a = _this.state, name = _a.name, scope = _a.scope;
            if (!name) {
                return;
            }
            _this.props.saveView(name, scope);
            _this.setState({
                name: '',
                showForm: false,
                id: '',
            });
        };
        _this.state = {
            name: '',
            showForm: false,
            id: '',
            scope: _this.props.scopes ? _this.props.scopes[0].slug : null,
        };
        return _this;
    }
    FilterSummary.prototype.handleChange = function (e) {
        var name = e.target.value;
        this.setState({ name: name });
    };
    FilterSummary.prototype.render = function () {
        var _this = this;
        var scopes = this.props.scopes;
        return (React.createElement(BorderedDiv, null,
            this.state.showForm && (React.createElement(Modal, { title: "Save current view", cancel: function () { return _this.setState({ showForm: false }); }, done: this.save, action: "Save" },
                React.createElement("form", { onSubmit: this.save },
                    !!scopes && scopes.length > 1 && (React.createElement(Flex, { mb: 30 },
                        React.createElement(Txt, { width: 90 }, "Visible to:"),
                        React.createElement(Select, { ml: 10, mt: "-7px", width: "auto", options: scopes, valueKey: "slug", labelKey: "name", value: scopes.find(function (x) { return x.slug === _this.state.scope; }), onChange: function (_a) {
                                var option = _a.option;
                                return _this.setState({
                                    scope: option.slug,
                                });
                            } }))),
                    React.createElement(Input, { width: "100%", value: this.state.name, placeholder: "Enter a name for the view", onChange: function (e) {
                            return _this.handleChange(e);
                        }, autoFocus: true })))),
            React.createElement(Flex, { justifyContent: "space-between" },
                React.createElement(Txt, { fontSize: 13, mb: 10, color: this.props.dark ? '#fff' : undefined },
                    "Filters (",
                    this.props.filters.length,
                    ")"),
                React.createElement(Button, { primary: true, plain: true, fontSize: 13, mt: -7, onClick: function () { return _this.setState({ showForm: !_this.state.showForm }); } },
                    React.createElement(FaBookmarkO, { style: { marginRight: 6 } }),
                    "Save view")),
            React.createElement(Flex, { flexWrap: "wrap" }, this.props.filters.map(function (filter, index) {
                return (React.createElement(Box, { mb: 10, mr: 10, key: index },
                    React.createElement(FilterDescription, { dark: _this.props.dark, filter: filter, edit: function () { return _this.props.edit(filter); }, delete: function () { return _this.props.delete(filter); } })));
            }))));
    };
    return FilterSummary;
}(React.Component));
export default FilterSummary;
var templateObject_1;
